import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine"
import "Turbine.Gameplay"

mainWinMini  = Turbine.UI.Label();
mainWinOff = Turbine.UI.Label();
mainWinDef = Turbine.UI.Label();
mainWinHeal = Turbine.UI.Label();
mainWinDebug = Turbine.UI.Label();

DpsWindow = class( Turbine.UI.Window );

function DpsWindow:Constructor()
	Turbine.UI.Window.Constructor( self );
	
	self:SetSize(157,143);
	self:SetPosition(200,200);
	--self:SetBackColor(Turbine.UI.Color( 0, 0, 0,1 ));
	self:SetBackground( "Freeplay/dass/Res/dpsWin.tga" );
    self:SetOpacity(0.7);
    self.isMini = false;
    self.frame = 1;
      self.mini = mainWinMini;
      self.mini:SetParent( self );
      self.mini:SetPosition( 0, 0 );
      self.mini:SetSize( 14, 12 );
      
      self.btnOff = mainWinOff;
      self.btnOff:SetParent( self );
      self.btnOff:SetPosition(14,21 );
      self.btnOff:SetSize( 30, 12 );
    
          self.btnDef = mainWinDef;
      self.btnDef:SetParent( self );
      self.btnDef:SetPosition(50,21 );
      self.btnDef:SetSize( 30, 12 );
            
        self.btnHeal = mainWinHeal;
      self.btnHeal:SetParent( self );
      self.btnHeal:SetPosition(87,21 );
      self.btnHeal:SetSize( 30, 12 );
      
      self.btnDebug = mainWinDebug;
      self.btnDebug:SetParent(self);
      self.btnDebug:SetPosition( 122, 19)
      self.btnDebug:SetSize( 30, 12 );
      self.btnDebug:SetBackColor(Turbine.UI.Color(0,0,0))
      self.btnDebug:SetText("Dbug");
      self.btnDebug:SetFont(Turbine.UI.Lotro.Font.Verdana12) 
          self.minDisp = Turbine.UI.Label();
      self.minDisp:SetParent( self );
      self.minDisp:SetPosition( 75, 2 );
      self.minDisp:SetSize( 65, 15 );
   self.minDisp:SetFont(Turbine.UI.Lotro.Font.Verdana12)   
   self.minDisp:SetText("CurrDps");
   
      self.label = Turbine.UI.Label();
      self.label:SetParent( self );
      self.label:SetPosition( 20, 40 );
      self.label:SetSize( 65, 20 );
   self.label:SetFont(Turbine.UI.Lotro.Font.Verdana10)   
   self.label:SetText("Cur DPS: ");
   
      self.dpslabel = Turbine.UI.Label();
      self.dpslabel:SetParent( self );
      self.dpslabel:SetPosition( 65, 40 );
      self.dpslabel:SetSize( 120, 20 );
      self.dpslabel:SetText("0 (0)");
      
      self.label2 = Turbine.UI.Label();
      self.label2:SetParent( self );
      self.label2:SetPosition( 20, 61 );
      self.label2:SetSize(65,20 );
       self.label2:SetFont(Turbine.UI.Lotro.Font.Verdana10)
      self.label2:SetText("TTL DPS: ");
     
      self.tdpslabel = Turbine.UI.Label();
      self.tdpslabel:SetParent( self );
      self.tdpslabel:SetPosition( 65, 61 );
      self.tdpslabel:SetSize( 120, 20 );
      self.tdpslabel:SetText("0 (0)");
      
      self.label3 = Turbine.UI.Label();
      self.label3:SetParent( self );
      self.label3:SetPosition( 20, 86 );
      self.label3:SetSize( 65, 20 );
      self.label3:SetFont(Turbine.UI.Lotro.Font.Verdana10)
      self.label3:SetText("TTL HITS: ");
      
      self.thitslabel = Turbine.UI.Label();
      self.thitslabel:SetParent( self );
      self.thitslabel:SetPosition( 65, 86 );
      self.thitslabel:SetSize( 120, 20 );
      self.thitslabel:SetText("0");
      self:SetVisible(true);
      
      self.label4 = Turbine.UI.Label();
      self.label4:SetParent( self );
      self.label4:SetPosition( 20, 108 );
      self.label4:SetSize( 69, 20 );
      self.label4:SetFont(Turbine.UI.Lotro.Font.Verdana10)
      self.label4:SetText("TTL CRITS: ");
      
      self.tcritslabel = Turbine.UI.Label();
      self.tcritslabel:SetParent( self );
      self.tcritslabel:SetPosition( 70, 108 );
      self.tcritslabel:SetSize( 200, 20 );
      self.tcritslabel:SetText("0 (0%)");

      self:SetVisible(true);
	    self.dragStartX = 0;
	    self.dragStartY = 0;
	    self.dragging = false;
	
end	-- dpsWin Class	
function mainWinDebug:MouseDown(args)
    if(dWin.IsVisible == true) then
        dWin:SetVisible(false)
     
    else
        dWin:SetVisible(true)
         
    end
end
function mainWinHeal:MouseDown(args) 
        if ( args.Button == Turbine.UI.MouseButton.Left ) then
             g = self:GetParent();
             g.frame = 3;
             setHeals()
        else
            resetHeal(Dps);
            setHeals();
        end
end
function setHeals()
        tWin.label:SetText("Cur HPS: ");
        tWin.label2:SetText("TTL HPS: ");
        tWin.label3:SetText("TTL HEALS: ");
        tWin.label4:SetText("");
         tWin.tcritslabel:SetText("");
        dm = Dps.currHPS
        dj = Dps.totalHPS
        dh = Dps.totalHeals;
        tWin.dpslabel:SetText(dm);
         tWin.tdpslabel:SetText(dj);
          tWin.thitslabel:SetText( " " .. dh);
end
function setDef()
        
      
        tWin.label:SetText("EVADES: ");
        tWin.label2:SetText("BLOCKS: ");
        tWin.label3:SetText("RESISTS: ");
        tWin.label4:SetText("PARRIED: ");
                               critPerc = Dps.parry / Dps.attacked;
                              
                               if(Dps.parry == 0 ) then
                                    tWin.tcritslabel:SetText("" .. Dps.parry .. " 0%");
                               else
                                critPerc = critPerc * 100;
                                ts = Dps:getPerc(critPerc);
                               
                               tWin.tcritslabel:SetText(" " .. Dps.parry .. " " .. ts .. "%");
                               end
                               critPerc = Dps.evade / Dps.attacked;
                               
                                if(Dps.evade == 0 ) then
                                    tWin.dpslabel:SetText(" " .. Dps.evade.. " 0%");
                               else
                                critPerc = critPerc * 100;
                                 ts = Dps:getPerc(critPerc);
                               tWin.dpslabel:SetText(" " .. Dps.evade .. " " .. ts .. "%");
                               end
                                critPerc = Dps.resist / Dps.attacked;
                               
                               if(Dps.resist == 0 ) then
                                    tWin.thitslabel:SetText(" " .. Dps.resist .. " 0%");
                               else
                                critPerc = critPerc * 100;
                                ts = Dps:getPerc(critPerc);
                               tWin.thitslabel:SetText(" " .. Dps.resist .. " " .. ts .. "%");
                               end
                                  critPerc = Dps.block / Dps.attacked;
                             
                                if(Dps.block == 0 ) then
                                    tWin.tdpslabel:SetText(" " .. Dps.block .. " 0%");
                               else
                                critPerc = critPerc * 100;
                               ts = Dps:getPerc(critPerc);
                               tWin.tdpslabel:SetText(" " .. Dps.block .. " " .. ts .. "%");
                               end
end
function mainWinDef:MouseDown(args) 
    if ( args.Button == Turbine.UI.MouseButton.Left ) then
        tWin.frame=2;
       setDef();
       else
          resetDef(Dps);
            setDef();
      end


end
function mainWinOff:MouseDown(args) 
    if ( args.Button == Turbine.UI.MouseButton.Left ) then
        g = self:GetParent();
        g.frame = 1;
        
        g.label:SetText("Cur DPS: ");
        g.label2:SetText("TTL DPS: ");
        g.label3:SetText("TTL HITS: ");
        g.label4:SetText("TTL CRITS: ");
                            dm = Dps:getPerc(tostring(Dps.curDPS));
                            tcc = dm;
                             tWin.dpslabel:SetText(tostring(dm).. "".."".."");
                             tWin.thitslabel:SetText(tostring(Dps.totalHits));
                               dm = Dps:getPerc(tostring(Dps.TotalDPS));
                             tWin.tdpslabel:SetText(tostring(dm) .. "".."".."");
                              if(Dps.crits > 0) then
                               critPerc = Dps.crits / Dps.totalHits;
                               critPerc = critPerc * 100;
                               ts = Dps:getPerc(critPerc);
                               if(tWin.frame == 1) then
                                    tWin.tcritslabel:SetText(" " .. Dps.crits .. " " .. ts .. "%");
                               end
                             else
                                if(tWin.frame == 1) then
                                    tWin.tcritslabel:SetText(" " .. Dps.crits .. " 0%");
                                 end
                             end 
       else
            ---------reset
            
            Dps:resetOff();
                    g = self:GetParent();
        g.frame = 1;
        g.minDisp:SetText("CurrDps");
        g.label:SetText("Cur DPS: ");
        g.label2:SetText("TTL DPS: ");
        g.label3:SetText("TTL HITS: ");
        g.label4:SetText("TTL CRITS: ");
        g.dpslabel:SetText("0")
        g.tdpslabel:SetText("0")
        g.thitslabel:SetText("0")
        g.tcritslabel:SetText("0")
       end

end

function mainWinMini:MouseDown(args) 
    
        g = self:GetParent();
        if(g.isMini == false) then
            g:SetSize(157,16);
            g.isMini = true;
        else
            g:SetSize(157,143);
            g.isMini = false;
        end 
end
function DpsWindow:MouseDown( args )

	if ( args.Button == Turbine.UI.MouseButton.Left ) then
		self.dragStartX = args.X;
		self.dragStartY = args.Y;
		self.dragging = true;
	end
end
function DpsWindow:MouseMove( args )
	local left, top = self:GetPosition();
	
	if ( self.dragging ) then
		self:SetPosition( left + ( args.X - self.dragStartX ), top + ( args.Y - self.dragStartY ) );
	end
end

function DpsWindow:MouseUp( args )
	if ( args.Button == Turbine.UI.MouseButton.Left ) then
		self.dragging = false;
	end
end